﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using C1.Win.C1FlexGrid;

namespace Sample_TreeCheck
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            _flex.Cols[0].Width = 30;
            _flex.Cols.Count = 2;
            _flex.ExtendLastCol = true;
            _flex.Tree.Column = 1;

            Random r = new Random();
            string[] s = "Iron|Steel|Titanium|Gold|Silver|Platinum|Copper|Zinc|Bronze".Split('|');
            int level = 0;
            _flex.Rows.Count = 1;
            for (int i = 1; i <= 1000; i++)
            {
                // add new node
                _flex.Rows.InsertNode(i, level);

                // set the text
                _flex[i, 1] = s[r.Next(s.Length - 1)] + " " + i.ToString();

                // set the check box
                _flex.SetCellCheck(i, 1, (r.NextDouble() > .5) ? CheckEnum.Checked : CheckEnum.Unchecked);

                // update level for next node
                if (level > 0 && r.NextDouble() > .75) level--;
                else if (level == 0 || r.NextDouble() > .8) level++;
            }
        }

       private void _flex_CellChecked(object sender, RowColEventArgs e)
        {
            int children = _flex.Rows[e.Row].Node.Children;
            int firstRow, lastRow;

            if (children > 0)
            {
                CellRange cr = _flex.Rows[e.Row].Node.GetCellRange();
                firstRow = cr.r1;
                lastRow = cr.r2;

                CheckEnum ck = _flex.GetCellCheck(e.Row, e.Col);

                for (int i = firstRow; i <= lastRow; i++)
                    _flex.SetCellCheck(i, e.Col, ck);
            }
        }
    }
}
